test-lib: turn on GIT_TEST_CHAIN_LINT by default
[git/git.git] / t / test-lib.sh
CommitLineData
c74c7203 1# Test framework for git. See t/README for usage.
e1970ce4
JH
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
c2116a17
JH
18# Keep the original TERM for say_color
19ORIGINAL_TERM=$TERM
20
3c8f12c9
JH
21# Test the binaries we have just built. The tests are kept in
22# t/ subdirectory and are run in 'trash directory' subdirectory.
23if test -z "$TEST_DIRECTORY"
24then
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
27 # itself.
28 TEST_DIRECTORY=$(pwd)
85176d72
FC
29else
30 # ensure that TEST_DIRECTORY is an absolute path so that it
31 # is valid even if the current working directory is changed
32 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
3c8f12c9
JH
33fi
34if test -z "$TEST_OUTPUT_DIRECTORY"
35then
36 # Similarly, override this to store the test-results subdir
37 # elsewhere
38 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
39fi
40GIT_BUILD_DIR="$TEST_DIRECTORY"/..
41
2006f0ad
RR
42################################################################
43# It appears that people try to run tests without building...
44"$GIT_BUILD_DIR/git" >/dev/null
45if test $? != 1
46then
47 echo >&2 'error: you do not seem to have built git yet.'
48 exit 1
49fi
50
3c8f12c9
JH
51. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
52export PERL_PATH SHELL_PATH
53
4cde519f
RR
54# if --tee was passed, write the output not only to the terminal, but
55# additionally to the file test-results/$BASENAME.out, too.
56case "$GIT_TEST_TEE_STARTED, $* " in
57done,*)
58 # do not redirect again
59 ;;
60*' --tee '*|*' --va'*)
2d14e13c
JK
61 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
62 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
4cde519f
RR
63 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
64 echo $? > $BASE.exit) | tee $BASE.out
65 test "$(cat $BASE.exit)" = 0
66 exit
67 ;;
68esac
69
e1970ce4
JH
70# For repeatability, reset the environment to known value.
71LANG=C
899460f3 72LC_ALL=C
d9bdd39e 73PAGER=cat
e1970ce4 74TZ=UTC
c2116a17
JH
75TERM=dumb
76export LANG LC_ALL PAGER TERM TZ
8ff99e74 77EDITOR=:
661bfd13
SL
78# A call to "unset" with no arguments causes at least Solaris 10
79# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
80# deriving from the command substitution clustered with the other
81# ones.
3c8f12c9 82unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
95a1d12e 83 my @env = keys %ENV;
730477f1
JL
84 my $ok = join("|", qw(
85 TRACE
86 DEBUG
87 USE_LOOKUP
88 TEST
89 .*_TEST
90 PROVE
91 VALGRIND
ac001282 92 UNZIP
edb54081 93 PERF_
e2a0ccc0 94 CURL_VERBOSE
730477f1
JL
95 ));
96 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
97 print join("\n", @vars);
98')
5adf84eb 99unset XDG_CONFIG_HOME
8bade1e1 100unset GITPERLLIB
29e55cd5
JH
101GIT_AUTHOR_EMAIL=author@example.com
102GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
103GIT_COMMITTER_EMAIL=committer@example.com
104GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f 105GIT_MERGE_VERBOSITY=5
f8246281
JH
106GIT_MERGE_AUTOEDIT=no
107export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
29e55cd5
JH
108export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
109export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 110export EDITOR
e1970ce4 111
124647c4
KB
112# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
113GIT_TRACE_BARE=1
114export GIT_TRACE_BARE
115
5d9fc888
TG
116if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
117then
118 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
119 export GIT_INDEX_VERSION
120fi
121
a731fa91
EP
122# Add libc MALLOC and MALLOC_PERTURB test
123# only if we are not executing the test with valgrind
1b3185fc 124if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
ee1431bf 125 test -n "$TEST_NO_MALLOC_CHECK"
1b3185fc
JH
126then
127 setup_malloc_check () {
128 : nothing
129 }
130 teardown_malloc_check () {
131 : nothing
132 }
133else
134 setup_malloc_check () {
135 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
136 export MALLOC_CHECK_ MALLOC_PERTURB_
137 }
138 teardown_malloc_check () {
139 unset MALLOC_CHECK_ MALLOC_PERTURB_
140 }
141fi
a731fa91 142
b0f4c908
JK
143: ${ASAN_OPTIONS=detect_leaks=0}
144export ASAN_OPTIONS
145
886a3907
JH
146# Protect ourselves from common misconfiguration to export
147# CDPATH into the environment
148unset CDPATH
149
5565f47c 150unset GREP_OPTIONS
ac001282 151unset UNZIP
5565f47c 152
3d5c0cc9 153case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1c0cc756
RJ
1541|2|true)
155 echo "* warning: Some tests will not work if GIT_TRACE" \
156 "is set as to trace on STDERR ! *"
157 echo "* warning: Please set GIT_TRACE to something" \
158 "other than 1, 2 or true ! *"
159 ;;
6ce4e61f
CC
160esac
161
cd3c095c
JH
162# Convenience
163#
164# A regexp to match 5 and 40 hexdigits
165_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
166_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
167
3749fde5
JH
168# Zero SHA-1
169_z40=0000000000000000000000000000000000000000
170
3f4ab627
JH
171# Line feed
172LF='
173'
174
a42643aa
JK
175# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
176# when case-folding filenames
177u200c=$(printf '\342\200\214')
178
179export _x05 _x40 _z40 LF u200c
342e9ef2 180
e1970ce4
JH
181# Each test should start with something like this, after copyright notices:
182#
183# test_description='Description of this test...
184# This test checks if command xyzzy does the right thing...
185# '
186# . ./test-lib.sh
e1970ce4 187
102fc80d 188unset color
e1970ce4
JH
189while test "$#" -ne 0
190do
191 case "$1" in
192 -d|--d|--de|--deb|--debu|--debug)
193 debug=t; shift ;;
886856ab
JH
194 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
195 immediate=t; shift ;;
5e2c08c6 196 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 197 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
0445e6f0
IB
198 -r)
199 shift; test "$#" -ne 0 || {
200 echo 'error: -r requires an argument' >&2;
201 exit 1;
202 }
203 run_list=$1; shift ;;
204 --run=*)
205 run_list=$(expr "z$1" : 'z[^=]*=\(.*\)'); shift ;;
e1970ce4 206 -h|--h|--he|--hel|--help)
570f3226 207 help=t; shift ;;
e1970ce4
JH
208 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
209 verbose=t; shift ;;
ff09af3f
TR
210 --verbose-only=*)
211 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
212 shift ;;
1ece1274 213 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
214 # Ignore --quiet under a TAP::Harness. Saying how many tests
215 # passed without the ok/not ok details is always an error.
216 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
217 --with-dashes)
218 with_dashes=t; shift ;;
55db1df0 219 --no-color)
faa4bc35 220 color=; shift ;;
4e1be63c 221 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
952af351
TR
222 valgrind=memcheck
223 shift ;;
224 --valgrind=*)
225 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
226 shift ;;
5dfc368f
TR
227 --valgrind-only=*)
228 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
229 shift ;;
44138559
JS
230 --tee)
231 shift ;; # was handled already
f423ef5f
JK
232 --root=*)
233 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
234 shift ;;
bb79af9d
JK
235 --chain-lint)
236 GIT_TEST_CHAIN_LINT=1
237 shift ;;
238 --no-chain-lint)
239 GIT_TEST_CHAIN_LINT=0
240 shift ;;
a136f6d8
JK
241 -x)
242 trace=t
243 verbose=t
244 shift ;;
e1970ce4 245 *)
1f729dca 246 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
247 esac
248done
249
26a07309 250if test -n "$valgrind_only"
5dfc368f
TR
251then
252 test -z "$valgrind" && valgrind=memcheck
253 test -z "$verbose" && verbose_only="$valgrind_only"
254elif test -n "$valgrind"
255then
256 verbose=t
257fi
952af351 258
55db1df0
PH
259error () {
260 say_color error "error: $*"
6e7b5aaf 261 GIT_EXIT_OK=t
55db1df0
PH
262 exit 1
263}
264
265say () {
266 say_color info "$*"
267}
268
570f3226
MB
269test "${test_description}" != "" ||
270error "Test script did not set test_description."
271
272if test "$help" = "t"
273then
cb1aefda 274 printf '%s\n' "$test_description"
570f3226
MB
275 exit 0
276fi
277
4d9d62fa 278exec 5>&1
781f76b1 279exec 6<&0
e1970ce4
JH
280if test "$verbose" = "t"
281then
282 exec 4>&2 3>&1
283else
284 exec 4>/dev/null 3>/dev/null
285fi
286
287test_failure=0
288test_count=0
41ac414e
JH
289test_fixed=0
290test_broken=0
2d84e9fb 291test_success=0
e1970ce4 292
d998bd4a
ÆAB
293test_external_has_tap=0
294
faa4bc35 295die () {
6e7b5aaf
CB
296 code=$?
297 if test -n "$GIT_EXIT_OK"
298 then
299 exit $code
300 else
301 echo >&5 "FATAL: Unexpected exit with code $code"
302 exit 1
303 fi
faa4bc35
CB
304}
305
6e7b5aaf 306GIT_EXIT_OK=
35641310 307trap 'die' EXIT
41184273 308
12a29b1a
TR
309# The user-facing functions are loaded from a separate file so that
310# test_perf subshells can have them too
3c8f12c9 311. "$TEST_DIRECTORY/test-lib-functions.sh"
05236a5e 312
886856ab 313# You are not expected to call test_ok_ and test_failure_ directly, use
3fa36666 314# the test_expect_* functions instead.
886856ab
JH
315
316test_ok_ () {
d5d9de1b 317 test_success=$(($test_success + 1))
633fe50a 318 say_color "" "ok $test_count - $@"
e1970ce4
JH
319}
320
886856ab 321test_failure_ () {
d5d9de1b 322 test_failure=$(($test_failure + 1))
633fe50a 323 say_color error "not ok $test_count - $1"
bf0dd8a8 324 shift
cb1aefda 325 printf '%s\n' "$*" | sed -e 's/^/# /'
6e7b5aaf 326 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
327}
328
41ac414e 329test_known_broken_ok_ () {
41ac414e 330 test_fixed=$(($test_fixed+1))
633fe50a 331 say_color error "ok $test_count - $@ # TODO known breakage vanished"
41ac414e
JH
332}
333
334test_known_broken_failure_ () {
41ac414e 335 test_broken=$(($test_broken+1))
633fe50a 336 say_color warn "not ok $test_count - $@ # TODO known breakage"
41ac414e 337}
886856ab
JH
338
339test_debug () {
8e832ebc 340 test "$debug" = "" || eval "$1"
e1970ce4
JH
341}
342
e6a6ddc9
TR
343match_pattern_list () {
344 arg="$1"
345 shift
346 test -z "$*" && return 1
347 for pattern_
348 do
349 case "$arg" in
350 $pattern_)
351 return 0
352 esac
353 done
354 return 1
355}
356
0445e6f0
IB
357match_test_selector_list () {
358 title="$1"
359 shift
360 arg="$1"
361 shift
362 test -z "$1" && return 0
363
364 # Both commas and whitespace are accepted as separators.
365 OLDIFS=$IFS
366 IFS=' ,'
367 set -- $1
368 IFS=$OLDIFS
369
370 # If the first selector is negative we include by default.
371 include=
372 case "$1" in
373 !*) include=t ;;
374 esac
375
376 for selector
377 do
378 orig_selector=$selector
379
380 positive=t
381 case "$selector" in
382 !*)
383 positive=
384 selector=${selector##?}
385 ;;
386 esac
387
388 test -z "$selector" && continue
389
390 case "$selector" in
391 *-*)
392 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
393 then
394 echo "error: $title: invalid non-numeric in range" \
395 "start: '$orig_selector'" >&2
396 exit 1
397 fi
398 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
399 then
400 echo "error: $title: invalid non-numeric in range" \
401 "end: '$orig_selector'" >&2
402 exit 1
403 fi
404 ;;
405 *)
406 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
407 then
408 echo "error: $title: invalid non-numeric in test" \
409 "selector: '$orig_selector'" >&2
410 exit 1
411 fi
412 esac
413
414 # Short cut for "obvious" cases
415 test -z "$include" && test -z "$positive" && continue
416 test -n "$include" && test -n "$positive" && continue
417
418 case "$selector" in
419 -*)
420 if test $arg -le ${selector#-}
421 then
422 include=$positive
423 fi
424 ;;
425 *-)
426 if test $arg -ge ${selector%-}
427 then
428 include=$positive
429 fi
430 ;;
431 *-*)
432 if test ${selector%%-*} -le $arg \
433 && test $arg -le ${selector#*-}
434 then
435 include=$positive
436 fi
437 ;;
438 *)
439 if test $arg -eq $selector
440 then
441 include=$positive
442 fi
443 ;;
444 esac
445 done
446
447 test -n "$include"
448}
449
ff09af3f
TR
450maybe_teardown_verbose () {
451 test -z "$verbose_only" && return
452 exec 4>/dev/null 3>/dev/null
453 verbose=
454}
455
456last_verbose=t
457maybe_setup_verbose () {
458 test -z "$verbose_only" && return
26a07309 459 if match_pattern_list $test_count $verbose_only
ff09af3f
TR
460 then
461 exec 4>&2 3>&1
462 # Emit a delimiting blank line when going from
463 # non-verbose to verbose. Within verbose mode the
464 # delimiter is printed by test_expect_*. The choice
465 # of the initial $last_verbose is such that before
466 # test 1, we do not print it.
467 test -z "$last_verbose" && echo >&3 ""
468 verbose=t
469 else
470 exec 4>/dev/null 3>/dev/null
471 verbose=
472 fi
473 last_verbose=$verbose
474}
475
5dfc368f
TR
476maybe_teardown_valgrind () {
477 test -z "$GIT_VALGRIND" && return
478 GIT_VALGRIND_ENABLED=
479}
480
481maybe_setup_valgrind () {
482 test -z "$GIT_VALGRIND" && return
26a07309 483 if test -z "$valgrind_only"
5dfc368f
TR
484 then
485 GIT_VALGRIND_ENABLED=t
486 return
487 fi
488 GIT_VALGRIND_ENABLED=
489 if match_pattern_list $test_count $valgrind_only
490 then
491 GIT_VALGRIND_ENABLED=t
492 fi
493}
494
a136f6d8
JK
495# This is a separate function because some tests use
496# "return" to end a test_expect_success block early
497# (and we want to make sure we run any cleanup like
498# "set +x").
499test_eval_inner_ () {
500 # Do not add anything extra (including LF) after '$*'
501 eval "
502 test \"$trace\" = t && set -x
503 $*"
504}
505
a7c58f28 506test_eval_ () {
a136f6d8
JK
507 # We run this block with stderr redirected to avoid extra cruft
508 # during a "-x" trace. Once in "set -x" mode, we cannot prevent
509 # the shell from printing the "set +x" to turn it off (nor the saving
510 # of $? before that). But we can make sure that the output goes to
511 # /dev/null.
512 #
513 # The test itself is run with stderr put back to &4 (so either to
514 # /dev/null, or to the original stderr if --verbose was used).
515 {
516 test_eval_inner_ "$@" </dev/null >&3 2>&4
517 test_eval_ret_=$?
518 if test "$trace" = t
519 then
520 set +x
521 if test "$test_eval_ret_" != 0
522 then
523 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
524 fi
525 fi
526 } 2>/dev/null
527 return $test_eval_ret_
a7c58f28
JN
528}
529
4d9d62fa 530test_run_ () {
b6b0afdc 531 test_cleanup=:
b586744a 532 expecting_failure=$2
bb79af9d 533
92b269f5 534 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
bb79af9d
JK
535 # 117 is magic because it is unlikely to match the exit
536 # code of other programs
537 test_eval_ "(exit 117) && $1"
538 if test "$?" != 117; then
539 error "bug in the test script: broken &&-chain: $1"
540 fi
541 fi
542
a57397b0 543 setup_malloc_check
a7c58f28 544 test_eval_ "$1"
b6b0afdc 545 eval_ret=$?
a57397b0 546 teardown_malloc_check
b586744a 547
a136f6d8
JK
548 if test -z "$immediate" || test $eval_ret = 0 ||
549 test -n "$expecting_failure" && test "$test_cleanup" != ":"
b586744a 550 then
1b3185fc 551 setup_malloc_check
a7c58f28 552 test_eval_ "$test_cleanup"
1b3185fc 553 teardown_malloc_check
b586744a 554 fi
1c0cc756
RJ
555 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
556 then
57e1538a
ÆAB
557 echo ""
558 fi
aa0bcf96 559 return "$eval_ret"
4d9d62fa
PR
560}
561
ae75342c 562test_start_ () {
8586f98b 563 test_count=$(($test_count+1))
ff09af3f 564 maybe_setup_verbose
5dfc368f 565 maybe_setup_valgrind
ae75342c
TR
566}
567
568test_finish_ () {
569 echo >&3 ""
5dfc368f 570 maybe_teardown_valgrind
ff09af3f 571 maybe_teardown_verbose
ae75342c
TR
572}
573
574test_skip () {
04ece593 575 to_skip=
ef2ac68d 576 skipped_reason=
e6a6ddc9
TR
577 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
578 then
579 to_skip=t
ef2ac68d 580 skipped_reason="GIT_SKIP_TESTS"
e6a6ddc9 581 fi
05236a5e
JN
582 if test -z "$to_skip" && test -n "$test_prereq" &&
583 ! test_have_prereq "$test_prereq"
a7bb3940
JS
584 then
585 to_skip=t
ef2ac68d 586
07431fc8 587 of_prereq=
05236a5e 588 if test "$missing_prereq" != "$test_prereq"
07431fc8 589 then
05236a5e 590 of_prereq=" of $test_prereq"
07431fc8 591 fi
ef2ac68d
IB
592 skipped_reason="missing $missing_prereq${of_prereq}"
593 fi
0445e6f0
IB
594 if test -z "$to_skip" && test -n "$run_list" &&
595 ! match_test_selector_list '--run' $test_count "$run_list"
596 then
597 to_skip=t
598 skipped_reason="--run"
599 fi
07431fc8 600
ef2ac68d
IB
601 case "$to_skip" in
602 t)
633fe50a 603 say_color skip >&3 "skipping test: $@"
ef2ac68d 604 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
04ece593
JH
605 : true
606 ;;
607 *)
608 false
609 ;;
610 esac
611}
612
342e9ef2
TR
613# stub; perf-lib overrides it
614test_at_end_hook_ () {
615 :
616}
617
e1970ce4 618test_done () {
6e7b5aaf 619 GIT_EXIT_OK=t
2d84e9fb 620
1c0cc756
RJ
621 if test -z "$HARNESS_ACTIVE"
622 then
342e9ef2 623 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
8ef1abe5 624 mkdir -p "$test_results_dir"
dd78478f
FC
625 base=${0##*/}
626 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
8ef1abe5 627
c54e6be7
ML
628 cat >>"$test_results_path" <<-EOF
629 total $test_count
630 success $test_success
631 fixed $test_fixed
632 broken $test_broken
633 failed $test_failure
634
635 EOF
8ef1abe5 636 fi
41ac414e
JH
637
638 if test "$test_fixed" != 0
639 then
633fe50a 640 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
41ac414e
JH
641 fi
642 if test "$test_broken" != 0
643 then
633fe50a 644 say_color warn "# still have $test_broken known breakage(s)"
b73d9a23
AS
645 fi
646 if test "$test_broken" != 0 || test "$test_fixed" != 0
647 then
648 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
649 msg="remaining $test_remaining test(s)"
11d54b8b 650 else
b73d9a23 651 test_remaining=$test_count
11d54b8b 652 msg="$test_count test(s)"
41ac414e 653 fi
e1970ce4 654 case "$test_failure" in
10b94e28 655 0)
5099b99d 656 # Maybe print SKIP message
bf4b7219
RJ
657 if test -n "$skip_all" && test $test_count -gt 0
658 then
659 error "Can't use skip_all after running some tests"
660 fi
46f32a99 661 test -z "$skip_all" || skip_all=" # SKIP $skip_all"
5099b99d 662
1c0cc756
RJ
663 if test $test_external_has_tap -eq 0
664 then
b73d9a23 665 if test $test_remaining -gt 0
d87bd7c1 666 then
633fe50a 667 say_color pass "# passed all $msg"
d87bd7c1 668 fi
633fe50a 669 say "1..$test_count$skip_all"
d998bd4a 670 fi
abc5d372
JS
671
672 test -d "$remove_trash" &&
673 cd "$(dirname "$remove_trash")" &&
674 rm -rf "$(basename "$remove_trash")"
675
342e9ef2
TR
676 test_at_end_hook_
677
e1970ce4
JH
678 exit 0 ;;
679
680 *)
1c0cc756
RJ
681 if test $test_external_has_tap -eq 0
682 then
633fe50a
TR
683 say_color error "# failed $test_failure among $msg"
684 say "1..$test_count"
d998bd4a 685 fi
5099b99d 686
e1970ce4
JH
687 exit 1 ;;
688
689 esac
690}
691
e4597aae 692if test -n "$valgrind"
4e1be63c 693then
4e1be63c
JS
694 make_symlink () {
695 test -h "$2" &&
696 test "$1" = "$(readlink "$2")" || {
697 # be super paranoid
698 if mkdir "$2".lock
699 then
700 rm -f "$2" &&
701 ln -s "$1" "$2" &&
702 rm -r "$2".lock
703 else
704 while test -d "$2".lock
705 do
706 say "Waiting for lock on $2."
707 sleep 1
708 done
709 fi
710 }
711 }
712
713 make_valgrind_symlink () {
36bfb0e5 714 # handle only executables, unless they are shell libraries that
11d62145 715 # need to be in the exec-path.
36bfb0e5 716 test -x "$1" ||
11d62145 717 test "# " = "$(head -c 2 <"$1")" ||
36bfb0e5 718 return;
4e1be63c
JS
719
720 base=$(basename "$1")
6cec5c68 721 symlink_target=$GIT_BUILD_DIR/$base
4e1be63c
JS
722 # do not override scripts
723 if test -x "$symlink_target" &&
724 test ! -d "$symlink_target" &&
725 test "#!" != "$(head -c 2 < "$symlink_target")"
726 then
727 symlink_target=../valgrind.sh
728 fi
efd92ffd
JS
729 case "$base" in
730 *.sh|*.perl)
731 symlink_target=../unprocessed-script
732 esac
4e1be63c
JS
733 # create the link, or replace it if it is out of date
734 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
735 }
736
26a07309
TR
737 # override all git executables in TEST_DIRECTORY/..
738 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
739 mkdir -p "$GIT_VALGRIND"/bin
740 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
741 do
742 make_valgrind_symlink $file
743 done
744 # special-case the mergetools loadables
745 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
746 OLDIFS=$IFS
747 IFS=:
748 for path in $PATH
749 do
750 ls "$path"/git-* 2> /dev/null |
751 while read file
ad0e6233 752 do
26a07309 753 make_valgrind_symlink "$file"
ad0e6233 754 done
26a07309
TR
755 done
756 IFS=$OLDIFS
4e1be63c
JS
757 PATH=$GIT_VALGRIND/bin:$PATH
758 GIT_EXEC_PATH=$GIT_VALGRIND/bin
759 export GIT_VALGRIND
952af351
TR
760 GIT_VALGRIND_MODE="$valgrind"
761 export GIT_VALGRIND_MODE
5dfc368f 762 GIT_VALGRIND_ENABLED=t
26a07309 763 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
5dfc368f 764 export GIT_VALGRIND_ENABLED
1c0cc756
RJ
765elif test -n "$GIT_TEST_INSTALLED"
766then
e4597aae
MO
767 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
768 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 769 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
770 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
771else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 772 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1c0cc756
RJ
773 if ! test -x "$git_bin_dir/git"
774 then
775 if test -z "$with_dashes"
776 then
e4597aae
MO
777 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
778 fi
779 with_dashes=t
780 fi
781 PATH="$git_bin_dir:$PATH"
6cec5c68 782 GIT_EXEC_PATH=$GIT_BUILD_DIR
1c0cc756
RJ
783 if test -n "$with_dashes"
784 then
6cec5c68 785 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 786 fi
4e1be63c 787fi
6cec5c68 788GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 789GIT_CONFIG_NOSYSTEM=1
3c995beb 790GIT_ATTR_NOSYSTEM=1
8f323c00 791export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 792
5e87eae9
JH
793if test -z "$GIT_TEST_CMP"
794then
795 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
796 then
797 GIT_TEST_CMP="$DIFF -c"
798 else
799 GIT_TEST_CMP="$DIFF -u"
800 fi
801fi
802
6cec5c68 803GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
6fcca938 804export GITPERLLIB
6cec5c68 805test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
806 error "You haven't built things yet, have you?"
807}
e1970ce4 808
1c0cc756
RJ
809if ! test -x "$GIT_BUILD_DIR"/test-chmtime
810then
56cf9806
EW
811 echo >&2 'You need to build test-chmtime:'
812 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
813 exit 1
814fi
815
e1970ce4 816# Test repository
002d4ce8
JK
817TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
818test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
819case "$TRASH_DIRECTORY" in
820/*) ;; # absolute path is good
821 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
f423ef5f 822esac
91c8b825 823test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
38b074de 824rm -fr "$TRASH_DIRECTORY" || {
6e7b5aaf 825 GIT_EXIT_OK=t
8d14ac94
JH
826 echo >&5 "FATAL: Cannot prepare test area"
827 exit 1
828}
829
90cff968 830HOME="$TRASH_DIRECTORY"
0ea47f9d
JH
831GNUPGHOME="$HOME/gnupg-home-not-used"
832export HOME GNUPGHOME
90cff968 833
102fc80d
RH
834# run the tput tests *after* changing HOME (in case ncurses needs
835# ~/.terminfo for $TERM)
836test -n "${color+set}" || test "x$ORIGINAL_TERM" != "xdumb" && (
837 TERM=$ORIGINAL_TERM &&
838 export TERM &&
839 test -t 1 &&
840 tput bold >/dev/null 2>&1 &&
841 tput setaf 1 >/dev/null 2>&1 &&
842 tput sgr0 >/dev/null 2>&1
843 ) &&
844 color=t
845
846if test -n "$color"
847then
848 say_color () {
849 (
850 TERM=$ORIGINAL_TERM
851 export TERM
852 case "$1" in
853 error)
854 tput bold; tput setaf 1;; # bold red
855 skip)
856 tput setaf 4;; # blue
857 warn)
858 tput setaf 3;; # brown/yellow
859 pass)
860 tput setaf 2;; # green
861 info)
862 tput setaf 6;; # cyan
863 *)
864 test -n "$quiet" && return;;
865 esac
866 shift
867 printf "%s" "$*"
868 tput sgr0
869 echo
870 )
871 }
872else
873 say_color() {
874 test -z "$1" && test -n "$quiet" && return
875 shift
876 printf "%s\n" "$*"
877 }
878fi
879
1c0cc756
RJ
880if test -z "$TEST_NO_CREATE_REPO"
881then
38b074de 882 test_create_repo "$TRASH_DIRECTORY"
342e9ef2 883else
38b074de 884 mkdir -p "$TRASH_DIRECTORY"
342e9ef2 885fi
1bd9c648
LW
886# Use -P to resolve symlinks in our working directory so that the cwd
887# in subprocesses like git equals our $PWD (for pathname comparisons).
38b074de 888cd -P "$TRASH_DIRECTORY" || exit 1
04ece593 889
d5d9de1b
JS
890this_test=${0##*/}
891this_test=${this_test%%-*}
e6a6ddc9
TR
892if match_pattern_list "$this_test" $GIT_SKIP_TESTS
893then
894 say_color info >&3 "skipping test $this_test altogether"
895 skip_all="skip all tests in $this_test"
896 test_done
897fi
f17e9fbb 898
8648732e
BC
899# Provide an implementation of the 'yes' utility
900yes () {
901 if test $# = 0
902 then
903 y=y
904 else
905 y="$*"
906 fi
907
908 while echo "$y"
909 do
910 :
911 done
912}
913
f17e9fbb
JS
914# Fix some commands on Windows
915case $(uname -s) in
916*MINGW*)
917 # Windows has its own (incompatible) sort and find
918 sort () {
919 /usr/bin/sort "$@"
920 }
921 find () {
922 /usr/bin/find "$@"
923 }
5397ea31
JS
924 sum () {
925 md5sum "$@"
926 }
4114156a
JS
927 # git sees Windows-style pwd
928 pwd () {
929 builtin pwd -W
930 }
ee9fb68c 931 # no POSIX permissions
6fd1106a 932 # backslashes in pathspec are converted to '/'
fb9a2bea 933 # exec does not inherit the PID
a94114ad 934 test_set_prereq MINGW
5f4e02e5 935 test_set_prereq NATIVE_CRLF
a31d0665 936 test_set_prereq SED_STRIPS_CR
97669eed 937 test_set_prereq GREP_STRIPS_CR
4d715ac0 938 GIT_TEST_CMP=mingw_test_cmp
a31d0665
RJ
939 ;;
940*CYGWIN*)
941 test_set_prereq POSIXPERM
a31d0665 942 test_set_prereq EXECKEEPSPID
cfa96496 943 test_set_prereq CYGWIN
a31d0665 944 test_set_prereq SED_STRIPS_CR
97669eed 945 test_set_prereq GREP_STRIPS_CR
ee9fb68c
JS
946 ;;
947*)
948 test_set_prereq POSIXPERM
6fd1106a 949 test_set_prereq BSLASHPSPEC
fb9a2bea 950 test_set_prereq EXECKEEPSPID
f17e9fbb
JS
951 ;;
952esac
704a3143 953
b082687c 954( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1b19ccd2 955test -z "$NO_PERL" && test_set_prereq PERL
d4e1b47a 956test -z "$NO_PYTHON" && test_set_prereq PYTHON
8f852ce6 957test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
5e9637c6 958test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1b19ccd2 959
bb946bba 960# Can we rely on git's output in the C locale?
30955229
JN
961if test -n "$GETTEXT_POISON"
962then
963 GIT_GETTEXT_POISON=YesPlease
964 export GIT_GETTEXT_POISON
5e9637c6 965 test_set_prereq GETTEXT_POISON
30955229
JN
966else
967 test_set_prereq C_LOCALE_OUTPUT
968fi
bb946bba 969
cabdee2c
JH
970# Use this instead of test_cmp to compare files that contain expected and
971# actual output from git commands that can be translated. When running
972# under GETTEXT_POISON this pretends that the command produced expected
973# results.
974test_i18ncmp () {
975 test -n "$GETTEXT_POISON" || test_cmp "$@"
976}
977
127df8c6
JH
978# Use this instead of "grep expected-string actual" to see if the
979# output from a git command that can be translated either contains an
980# expected string, or does not contain an unwanted one. When running
981# under GETTEXT_POISON this pretends that the command produced expected
982# results.
983test_i18ngrep () {
984 if test -n "$GETTEXT_POISON"
985 then
986 : # pretend success
987 elif test "x!" = "x$1"
988 then
989 shift
990 ! grep "$@"
991 else
992 grep "$@"
993 fi
994}
995
20073274
AS
996test_lazy_prereq PIPE '
997 # test whether the filesystem supports FIFOs
9443605b
ML
998 case $(uname -s) in
999 CYGWIN*)
1000 false
1001 ;;
1002 *)
1003 rm -f testfifo && mkfifo testfifo
1004 ;;
1005 esac
20073274
AS
1006'
1007
04083f27
JH
1008test_lazy_prereq SYMLINKS '
1009 # test whether the filesystem supports symbolic links
1010 ln -s x y && test -h y
1011'
c91cfd19 1012
b018c735
JN
1013test_lazy_prereq FILEMODE '
1014 test "$(git config --bool core.filemode)" = true
1015'
1016
ac39aa61
MG
1017test_lazy_prereq CASE_INSENSITIVE_FS '
1018 echo good >CamelCase &&
1019 echo bad >camelcase &&
1020 test "$(cat CamelCase)" != good
1021'
1022
5b0b5dd4
MG
1023test_lazy_prereq UTF8_NFD_TO_NFC '
1024 # check whether FS converts nfd unicode to nfc
1025 auml=$(printf "\303\244")
1026 aumlcdiar=$(printf "\141\314\210")
1027 >"$auml" &&
1028 case "$(echo *)" in
1029 "$aumlcdiar")
1030 true ;;
1031 *)
1032 false ;;
1033 esac
1034'
1035
09feffb6
JK
1036test_lazy_prereq AUTOIDENT '
1037 sane_unset GIT_AUTHOR_NAME &&
1038 sane_unset GIT_AUTHOR_EMAIL &&
1039 git var GIT_AUTHOR_IDENT
1040'
1041
6219bb22
JH
1042test_lazy_prereq EXPENSIVE '
1043 test -n "$GIT_TEST_LONG"
1044'
1045
e1ecd9e3
JH
1046test_lazy_prereq USR_BIN_TIME '
1047 test -x /usr/bin/time
1048'
1049
1767c517
JK
1050test_lazy_prereq NOT_ROOT '
1051 uid=$(id -u) &&
1052 test "$uid" != 0
1053'
1054
f400e51c
TB
1055# On a filesystem that lacks SANITY, a file can be deleted even if
1056# the containing directory doesn't have write permissions, or a file
1057# can be accessed even if the containing directory doesn't have read
1058# or execute permissions, causing our tests that validate that Git
1059# works sensibly in such situations.
1060test_lazy_prereq SANITY '
1061 mkdir SANETESTD.1 SANETESTD.2 &&
1062
1063 chmod +w SANETESTD.1 SANETESTD.2 &&
1064 >SANETESTD.1/x 2>SANETESTD.2/x &&
1065 chmod -w SANETESTD.1 &&
1066 chmod -rx SANETESTD.2 ||
1067 error "bug in test sript: cannot prepare SANETESTD"
1068
1069 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1070 status=$?
1071
1072 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1073 rm -rf SANETESTD.1 SANETESTD.2 ||
1074 error "bug in test sript: cannot clean SANETESTD"
1075 return $status
1076'
f838ce58
JK
1077
1078GIT_UNZIP=${GIT_UNZIP:-unzip}
1079test_lazy_prereq UNZIP '
1080 "$GIT_UNZIP" -v
1081 test $? -ne 127
1082'